import os
from itertools import product

# Define different learning rates for learning rate tuning
parameters = dict(
    n_hidden=[32, 64, 128],
    policy_lr=[0.001, 0.0001, 0.00001],
    value_lr=[0.01, 0.001, 0.0001, 0.00001]
)

param_values = [v for v in parameters.values()]
print(param_values)

for n_hidden, policy_lr, value_lr in product(*param_values):
    print(n_hidden, policy_lr, value_lr)

# Generate different learning rate combinations
for run_id, (n_hidden, policy_lr, value_lr) in enumerate(product(*param_values)):
    print('Run id: ', run_id + 1)
    print('Number of hidden neurons: ', n_hidden)
    print('Policy learning rate: ', policy_lr)
    print('Value learning rate: ', value_lr)
    os.system(
        f"python train_reinforce.py --save_path {run_id + 1} --n_hidden {n_hidden} --lr_policy {policy_lr} --lr_value {value_lr} --n_episode 50000 ")
